;________________________________________________________________________
;
;                       W M 9 1 8 C T R . A S M
;________________________________________________________________________
;
; WM-918/WX-200 Record WX code - by Max IK3SVW - January 2006
; Based on original u2k package by Byon Garrabrant, N6BG
;________________________________________________________________________
	cblock
		hex1
		hex2
		hex3
		dateL
		timeL
		timeH
		directionH
		directionL
		speedL_barovar
		speedH
		gustL_aux
		gustH
		tempL
		tempH
		baroL
		baroH
		humidL
		raintotL
		raintotH
		offsetRtotL
		offsetRtotH
		rainPL
		rainPH
		rain1hL
		rain1hH
		rainrL
		rainrH
		bhist0
		bhist1
		bhist2
		bhist3
		bhist4
		barotrend
		auxbaro			
		auxrain

		snowflag

		checksum
	endc
;________________________________________________________________________

mul16	skpz		; 16 bit multiplication by w
	 goto mul161	; skip if multiply by zero.
	return
mul161	movwf	hex3	; no zero-check entry point
sum16	movfw	temp	; 16-bit sum of hex1&hex2 + temp&temp2
	addwf	hex1, f	; result in hex1-hex2, temp-temp2 ummodified
	skpnc		; skip if result of hex1+temp is <256
	 incf	hex2, f
	movfw	temp2	
	addwf	hex2, f
	decfsz	hex3, f	; check if continue multiplication
	 goto sum16
	return
;________________________________________________________________________

dec1hex	movwf	hex1	; convert 1 byte (2 dec nibbles) in hex
	andlw	H'F0'	; take high nibble
	movwf	hex2
	clrc		; clear carry		
	rrf	hex2,w
	movwf 	hex3
	rrf	hex2,f
	rrf	hex2,f
	rrf	hex2,w
	addwf	hex3,f	; convert to decimal
	movf	hex1,w
	andlw	H'0F'	; take low nibble
	addwf	hex3,w	; combine low nibble with converted high nibble
	return
;________________________________________________________________________

neg_temp			; make 16-bit temperature negative
	comf	tempL, f
	comf	tempH, f
	incf	tempL, f
	skpnz
	 incf	tempH, f	; make temperature negative
	return
;________________________________________________________________________

serLoop	movwf	hex1	; read w bytes from serial port
serL1	call 	serialReceive
	addwf	checksum,f
	decfsz	hex1, f
	 goto	serL1
	return
;________________________________________________________________________
serialReceiveCk
	call	serialReceive
	addwf	checksum,f
	return
;________________________________________________________________________

Decode8F			; called to extract paramters from serial stream
				; when called, group byte (0x8F) has already been heard
	bsf	VALID_OUT	; turn on valid LED

; Extract fields we need

	call	serialReceiveCk	; skip 1 byte
	call	serialReceiveCk
	movwf	timeL		; minute
	call	serialReceiveCk
	movwf	timeH		; hour
	call	serialReceiveCk
	movwf	dateL		; day

	movlw	D'16'		; skip 15 bytes and get 1 byte
	call	serLoop
	movwf	humidL		; humidity

	movlw	D'13'		; skip remaining bytes
	call	serLoop
	call	serialReceive	; read checksum byte
	xorwf	checksum, w
	skpnz	
	 bsf	alldecoded,0	; checksum is ok

	goto	allChk
;________________________________________________________________________

Decode9F			; called to extract paramters from serial stream
				; when called, group byte (0x9F) has already been heard
	bsf	VALID_OUT	; turn on valid LED

	movlw	D'16'		; skip 15 bytes and read 1 byte
	call	serLoop
	movwf	tempL
	call	serialReceiveCk
	movwf	tempH		; temperature
	bcf	alldecoded,7
	btfsc	tempH,3		; check if negative
	 bsf	alldecoded,7
	andlw	H'07'
	movwf	tempH

	movlw	D'15'		; skip remaining bytes
	call	serLoop
	call	serialReceive	; read checksum byte
	xorwf	checksum, w
	skpnz	
	 bsf	alldecoded,1

	goto	allChk
;________________________________________________________________________

DecodeAF			; called to extract paramters from serial stream
				; when called, group byte (0xAF) has already been heard
	bsf	VALID_OUT	; turn on valid LED

	movlw	D'3'		; skip 2 bytes and read 1 byte
	call	serLoop
	movwf	baroL
	call	serialReceiveCk
	movwf	baroH		; pressure
	andlw	H'0F'
	addwf	baroL, f
	swapf	baroL, f
	movlw	H'F0'
	andwf	baroH, f
	call	serialReceiveCk
	andlw	H'0F'
	addwf	baroH, f
	swapf	baroH, f
	call	serialReceiveCk
	movwf	barotrend	; barometer trend

	movlw	D'23'		; skip remaining bytes
	call	serLoop
	call	serialReceive	; read checksum byte
	xorwf	checksum, w
	skpnz	
	 bsf	alldecoded,2

	goto	allChk
;________________________________________________________________________

DecodeBF			; called to extract paramters from serial stream
				; when called, group byte (0xBF) has already been heard
	bsf	VALID_OUT	; turn on valid LED

	movlw	D'5'		; skip 4 bytes and read 1 byte
	call	serLoop
	movwf	raintotL	; total rain
	call	serialReceiveCk
	movwf	raintotH

	movlw	D'6'		; skip remaining bytes
	call	serLoop
	call	serialReceive	; read checksum byte
	xorwf	checksum, w
	skpnz	
	 bsf	alldecoded,3

	goto	allChk
;________________________________________________________________________

DecodeCF			; called to extract paramters from serial stream
				; when called, group byte (0xCF) has already been heard
	bsf	VALID_OUT	; turn on valid LED

; Extract fields we need

	call	serialReceiveCk
	movwf	gustL_aux
	call	serialReceiveCk
	andlw	0x0F
	movwf	gustH		; wind gust
	call	serialReceiveCk	; skip 1 byte
	call	serialReceiveCk
	movwf	speedL_barovar	; wind speed
	call	serialReceiveCk
	movwf	hex1
	andlw	0xF0
	movwf	directionL	; wind direction
	movf	hex1,w
	andlw	0x0F
	movwf	speedH
	call	serialReceiveCk
	movwf	directionH

	movlw	D'19'		; skip remaining bytes
	call	serLoop
	call	serialReceive	; read checksum byte
	xorwf	checksum, w
	skpnz	
	 bsf	alldecoded,4

	goto	allChk
;________________________________________________________________________

Shift4Baro			; shift pressure history trough 4 hours
	movfw	bhist3
	movwf	bhist4
	movfw	bhist2
	movwf	bhist3
	movfw	bhist1
	movwf	bhist2
StoreBaro			; store last pressure in history
	movfw	bhist0
	movwf	bhist1
	return
;________________________________________________________________________

CommonDecHex
	call	dec1hex
	movwf	hex1
	clrf	hex2
	movlw	D'100'
	movwf	temp
	clrf	temp2
	return
;________________________________________________________________________

mstomph				; m/s to miles/hour conversion
	movfw	hex1		; i.e. multiply by 22 (2.2 * 10)
	movwf	temp
	movfw	hex2
	movwf	temp2
	movlw	D'23'		; really multiply by 23 for rounding
	call	mul161		; integer values
	movfw	hex1
	return
;________________________________________________________________________

convertWX
; Fix units and modify the data to be in BCD format,
; so there are no conversion delays while transmitting.
;________________________________________________________________________

; wind speed conversion from Dec To Hex
	movfw	speedL_barovar
	call	CommonDecHex
	movfw	speedH
	call	mul16

; m/s to miles/hour conversion
	call	mstomph
	movwf	speedL_barovar
	movfw	hex2
	movwf	speedH

	movlw	speedL_barovar	; BCD conversion of wind speed
	movwf	fsr		; only speedH will be used in wx
	call	bin2pack	; bcn, so speedL_barovar is avaiable
;________________________________________________________________________

; wind gust conversion from Dec To Hex
	movfw	gustL_aux
	call	CommonDecHex
	movfw	gustH
	call	mul16

; m/s to miles/hour conversion
	call	mstomph
	movwf	gustL_aux
	movfw	hex2
	movwf	gustH

	movlw	gustL_aux	; BCD conversion of wind gust
	movwf	fsr		; only gustH will be used in wx
	call	bin2pack	; beacon, so gustL_aux is avaiable
;________________________________________________________________________

; check temp error figure (EE hex)
	movfw	tempL
	xorlw	H'EE'
	skpnz		; if temp error
	 goto	rainc	; skip temp conversion

; temp conversion from Dec To Hex
	movfw	tempL
 	call	CommonDecHex
	movfw	tempH
	call	mul16

; if temp below 2C set snow flag

	bcf	snowflag,0	; clear snow flag
	btfsc	alldecoded,7	; negative temp (C) ?
	 goto	cksnw		; yes, set snow flag
	movfw	hex2		; no, check degrees
	skpz			; ten degrees are 0 ?
	 goto	C_to_F		; no, continue	
	movfw	hex1		; yes, check degrees
	sublw	D'20'
	skpnc			; temp < 2C ?
cksnw	 bsf	snowflag,0	; yes, set snow flag

; C to F conversion 1st step: multiply by 18 (9/5 * 10)
C_to_F 	movfw	hex1
	movwf	temp
	movfw	hex2
	movwf	temp2
	movlw	D'17'
	call	mul161

	movfw	hex2		; BCD conversion of temp,
	movwf	hex3		; really used for dividing by 100
	movfw	hex1
	movwf	hex2
	movlw	hex2
	movwf	fsr
	call	bin2pack

; convert High Order Byte Temp (0-99) from Dec to Hex
	movfw	hex3
	call	dec1hex
	movwf	tempL
	clrf	tempH

; check if C temperature has negative sign.
	btfsc	alldecoded, 7
	 call	neg_temp

; C to F conversion 2nd step: add 32
	movlw	D'32'
	addwf	tempL, f
	skpnc
	 incf	tempH, f

; check if converted F temperature is negative.
	bcf	alldecoded, 7
	btfss	tempH, 7
	 goto	tewmc1		; if temp is negative then
	bsf	alldecoded, 7	; set a flag and
	call	neg_temp	; make temp negative

tewmc1	movlw	tempL		; BCD conversion of temp
	movwf	fsr
	call	bin2pack
;________________________________________________________________________

; total rain conversion from Dec To Hex
rainc	movfw	raintotH
 	call	dec1hex
	movwf	raintotH
	movfw	raintotL
 	call	CommonDecHex
	movfw	raintotH
	call	mul16

; mm/h to inch/h cent conversion (multiply by 4)
	clrc
	rlf	hex1, f
	rlf	hex2, f
	clrc
 	rlf	hex1, f
	rlf	hex2, f

; store converted total rain value
  	movfw	hex1
	movwf	raintotL
	movfw	hex2
	movwf	hex3
	movwf	raintotH

; rain since last hour calculation
	movfw	rain1hL
	subwf	raintotL, w
	movwf	rainrL
	skpc
	 decf	hex2, f
	movfw	rain1hH
	subwf	hex2, w
	movwf	rainrH
	
; rain since last day (midnight) calculation
	movfw	offsetRtotL
	subwf	raintotL, w
	movwf	rainPL
	skpc
	 decf	hex3, f
	movfw	offsetRtotH
	subwf	hex3, w
	movwf	rainPH

	movlw	rainrL		; BCD conversion of 1h rain
	movwf	fsr
	call	bin2pack

	movlw	rainPL		; BCD conversion of Daily rain
	movwf	fsr
	call	bin2pack
;________________________________________________________________________

; baro conversion from Dec To Hex
	movfw	baroH
 	call	dec1hex
	movwf	gustL_aux
	movfw	baroL
 	call	CommonDecHex
	movfw	gustL_aux
	call	mul161

; convert QFE to QNH adding sea level difference
	movlw	OPT_SEA_LEVEL
	call	Get_Option	; get sea level low byte difference
	addwf	hex1, w		; add to baro low byte hex1
	movwf	hex3
	movwf	baroL		; store result in hex3 and baroL
	skpnc			; if result is >255
	 incf	hex2, f		;  increment baro high byte hex2
	movfw	hex2
	movwf	baroH		; store baro high byte in baroH
	movlw	baroL		; BCD conversion of baro value
	movwf	fsr
	call	bin2pack
	
; normalize pressure to 1 byte and store it
	movlw	H'1B'
	subwf	hex3, w
	movwf	bhist0	

; 4h pressure variation calculation
	movfw	bhist4		; get 4 hours ago pressure from history
	subwf	bhist0, w	; get press variation since 4 hours
	bcf	alldecoded, 5
	skpnc			; check press variation
	 goto	pv4h1
	bsf	alldecoded, 5	; if negative set a flag
	clrf	temp	
	subwf	temp, w		; and make it positive
pv4h1	movwf	speedL_barovar	; store press variation for BCD

	movlw	speedL_barovar	; BCD conversion of press variation
	movwf	fsr
	goto	bin2byte
;________________________________________________________________________
